unit TestComp;

interface

uses
    SysUtils, Classes, Controls, DesignIntf, DesignEditors;

type
    TMyStringsProperty = class(TClassProperty)
    public
        function GetAttributes: TPropertyAttributes; override;
        procedure Edit; override;
    end;
    TTestComp = class(TComponent)
    private
        FStrings: TStrings;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
    published
        property Strings: TStrings read FStrings write FStrings;
    end;

procedure Register;

implementation

uses StringsEditor;

procedure Register;
begin
    RegisterComponents('William', [TTestComp]);
    RegisterPropertyEditor(TypeInfo(TStrings),TTestComp,'Strings',TMyStringsProperty);
end;

{ TTestComp }

constructor TTestComp.Create(AOwner: TComponent);
begin
    inherited;
    FStrings := TStringList.Create;
end;

destructor TTestComp.Destroy;
begin
    FStrings.Free;
    inherited;
end;

{ TMyStringsProperty }

procedure TMyStringsProperty.Edit;
var
    MyEditor: TMyStringsEditor;
    Strings: TStrings;
begin
    MyEditor := TMyStringsEditor.Create(nil);
    try
        Strings := TStrings(GetOrdValue);
        MyEditor.ValueListEditor1.Strings.Assign(Strings);
        if MyEditor.ShowModal=mrOk then
            Strings.Assign(MyEditor.ValueListEditor1.Strings);
    finally
        MyEditor.Free;
    end;
end;

function TMyStringsProperty.GetAttributes: TPropertyAttributes;
begin
    Result := inherited GetAttributes + [paDialog] - [paSubProperties];
end;

end.
